<template>
    <section>
        <template v-if="loading || fail">
            <div class="text-center m-5 p-5">
                <span class="h2" v-if="loading"><i class="fas fa-spinner fa-spin"></i></span>
                <span class="h4" v-if="fail">
                    {{ fail.message }} <br>
                    <a href="#" class="btn btn-outline-primary mt-3" v-on:click.prevent="loadAdUnit">Retry</a>
                </span>
            </div>
        </template>

        <template v-else>

            <span style="float: right; position: relative" v-if="adUnit.size !== 'telegram'"><router-link v-bind:to="'/publisher/my-contents/' + this.$route.params.content + '/ad-units/' + adUnit.id + '/edit'" class="font-weight-bold h5 mb-0"><i class="far fa-edit"></i> EDIT</router-link> </span>

            <h2>{{ adUnit.name }}</h2>
            <span class="text-small text-muted">For {{ adUnit.content.name }}, {{ adUnit.size }}</span>

            <div class="card p-3 mt-2 bg-secondary text-white">
                <h3 class="card-title">Ad Unit Performance</h3>
                <div class="card-body row">
                    <div class="col-3">
                        <span class="h3">{{ adUnit.views }}</span>
                        <br>Impressions
                    </div>

                    <div class="col-3">
                        <span class="h3">{{ adUnit.clicks }}</span>
                        <br>Clicks
                    </div>

                    <div class="col-3">
                        <span class="h3">{{Number((adUnit.clicks / adUnit.views) * 100).toFixed(2) }} %</span>
                        <br>CTR
                    </div>

                    <div class="col-3">
                        <span class="h3">Br {{ Number((adUnit.views * 0.5) + (adUnit.clicks * 1.5)).toFixed(2) }}</span>
                        <br>Earning
                    </div>
                </div>
            </div>

            <hr>

            <h3>Implementation Instructions</h3>

            <template v-if="adUnit.content.type === 'website'">
                <p>Copy and paste the following snippet in to your html code.</p>

                <div class="alert alert-secondary">
                <pre class="mb-0">
                    <code>
&lt;<span class="text-success">iframe</span> <span class="text-info">width</span>="{{frameWidth}}" <span class="text-info">height</span>="{{frameHeight}}" <span class="text-info">scrolling</span>="no" <span class="text-info">style</span>="border: 0;" <span class="text-info">src</span>="{{frameUrl}}" &gt;
&lt;/<span class="text-success">iframe</span>&gt;
                    </code>
                </pre>
                </div>

                <p>That's it.</p>
            </template>

            <template v-if="adUnit.content.type === 'telegram'">

                <p>Follow the following instruction to start showing ads on your Telegram channel.</p>

                <ol>
                    <li>Add our bot, @ThunderAdsBot, to your channel as an administrator with all the permissions granted.</li>

                    <li>Post the following message on the channel to confirm you're the owner of the channel. Don't worry, the bot will automatically delete the message once confirmed.</li>
                </ol>

                <div class="alert alert-secondary">
                <pre class="mb-0">
                    <code>
<span class="text-info">q1x8jrellhw8{{adUnit.id}}w34xsce29lv</span>
                    </code>
                </pre>
                </div>

                <p>That's it. The bot will automatically start posting ads when ever you post new posts.</p>

            </template>

            <template v-if="adUnit.content.type === 'android'">
                <p>Follow the following instruction to start showing ads on your Android app. <br>
                    <small>If you already have another ad unit running in the app, you can skip to step 7.</small>
                </p>

                <ol>

                    <li>Download the Thunder Ads Android SDK <a href="/thunderads.aar">from here</a>.<br>
                        It's important that you do not change the file name when you download it.</li>

                    <li>Open your project on Android Studio and go to File > New > Module</li>

                    <li>Select "Import JAR/AAR Package"</li>

                    <li>Select the file you just downloaded on step 1 and click finish.</li>

                    <li>Open your apps build.gradle file.</li>

                    <li>
                        Add the following line to the 'dependencies' section of the file.
                        <p><code>implementation project(":thunderads")</code></p>
                    </li>

                    <li>Add the following code to your layout file where you want the ad to appear</li>

                </ol>

                <div class="alert alert-secondary">
                <pre class="mb-0">
                    <code>
<span class="text-success">
    &lt;tk.thunderads.thunderads.AdView
        android:id="@=id/your_id_here"
        android:layout_height="wrap_content"
        android:layout_width="match_parent"
        app:ad_height="{{ frameHeight - 5 }}"
        app:ad_width="{{ frameWidth - 5 }}"
        app:ad_unit="{{adUnit.id}}"
    /&gt;
</span>
                    </code>
                </pre>
                </div>

                <p>That's it.</p>
            </template>




        </template>
    </section>
</template>

<script>
    export default {
        data: function () {
            return {
                // Data
                adUnit: '',

                // Implementation Instruction Data
                frameUrl: '',
                frameWidth: null,
                frameHeight: null,

                // Loading Flag
                loading: false,

                // Fail Flag
                fail: '',
            }
        },
        methods: {
            loadAdUnit: function () {
                // Show the loading
                this.loading = true;

                // Clear previous flags
                this.fail = false;

                // Make a request to the server
                // Make a request to the server
                axios.get('/api/publisher/content/' + this.$route.params.content + '/ad-units/' + this.$route.params.ad)
                    .then(response => {
                        this.adUnit = response.data;

                        this.setImplementationData();
                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 404) {
                                this.fail = {
                                    'message': 'Ad Unit Not Found'
                                };
                            } else if (error.response.status === 403 || error.response.status === 401) {
                                this.fail = {
                                    'message' : 'Looks like you\'re not authorized to access this Ad Unit.'
                                };
                            } else {
                                this.fail = {
                                    message: error.response.stats + ' Something went wrong.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Check the log.'
                            };
                        }
                    })
                    .then(e => {
                        this.loading = false;
                    });
            },
            setImplementationData: function () {
                if (this.adUnit) {
                    let size = this.adUnit.size.split("X", 2);
                    this.frameWidth = parseInt(size[0]) + 5;
                    this.frameHeight = parseInt(size[1]) + 5;

                    this.frameUrl = this.adUnit.root_url + '/ads/get' + '?ad-unit=' + this.adUnit.id;
                }
            }
        },
        watch: {
            '$route.params.content': function(id) {
                this.contentId = id;
                this.loadAdUnit();
            },
            '$route.params.ad': function(id) {
                this.contentId = id;
                this.loadAdUnit();
            }
        },
        mounted() {
            console.log('Publisher - Ad Unit mounted.');

            // Load the ad units
            this.loadAdUnit();
        }
    }
</script>
